//+------------------------------------------------------------------+
//|                            Quantile based signed volume analysis |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    Periods             = 20;
extern int    Price               = PRICE_CLOSE;
extern double UpQuantilePercent   = 90;
extern double DownQuantilePercent = 10;

//
//
//
//
//

double bufferUp[];
double bufferDn[];
double quantUp[];
double quantDn[];
double prices[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,bufferUp); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,bufferDn); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,quantUp);
      SetIndexBuffer(3,quantDn);
      SetIndexBuffer(4,prices);
      
      //
      //
      //
      //
      //
      
      Periods             = MathMax(Periods,1);
      UpQuantilePercent   = MathMax(MathMin(UpQuantilePercent,100),0);
      DownQuantilePercent = MathMax(MathMin(DownQuantilePercent,100),0);
   IndicatorShortName("Quantile based signed volume analysis ("+Periods+","+DoubleToStr(UpQuantilePercent,2)+","+DoubleToStr(DownQuantilePercent,2)+")");
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      quantUp[i] = iQuantile(Periods,UpQuantilePercent  ,i);
      quantDn[i] = iQuantile(Periods,DownQuantilePercent,i);
      
      //
      //
      //
      //
      //
      
      bufferUp[i] = 0;
      bufferDn[i] = 0;
      for (int k=0; k<Periods; k++)
      {
         if (prices[i+k]>quantUp[i+k]) bufferUp[i]+= Volume[i+k];
         if (prices[i+k]<quantDn[i+k]) bufferDn[i]-= Volume[i+k];
      }         
   }         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double quantileArray[];
double iQuantile(int period, double qp, int i)
{
   if (ArraySize(quantileArray)!=period) ArrayResize(quantileArray,period);
                  for(int k=0; k<period && (i+k)<Bars; k++) quantileArray[k] = prices[i+k];
       ArraySort(quantileArray);

   //
   //
   //
   //
   //
   
   double index = (period-1)*qp/100.00;
   int    ind   = index;
   double delta = index - ind;
   if (ind == NormalizeDouble(index,5))
         return(            quantileArray[ind]);
   else  return((1.0-delta)*quantileArray[ind]+delta*quantileArray[ind+1]);
}